diff --git a/contrib/ci/build_and_install_rpms.sh b/contrib/ci/build_and_install_rpms.sh
index c16ef08857..01f00f37ed 100755
--- a/contrib/ci/build_and_install_rpms.sh
+++ b/contrib/ci/build_and_install_rpms.sh
@@ -11,7 +11,7 @@ meson .. \
     -Denable-man=true \
     -Denable-tests=true \
     -Denable-dummy=true \
-    -Denable-thunderbolt=false \
+    -Denable-thunderbolt=true \
     -Denable-uefi=true \
     -Denable-dell=true \
     -Denable-synaptics=true \
diff --git a/contrib/ci/build_and_test.sh b/contrib/ci/build_and_test.sh
index eafecf5551..bec558837a 100755
--- a/contrib/ci/build_and_test.sh
+++ b/contrib/ci/build_and_test.sh
@@ -9,7 +9,7 @@ meson .. \
     -Denable-doc=true \
     -Denable-man=true \
     -Denable-tests=true \
-    -Denable-thunderbolt=false \
+    -Denable-thunderbolt=true \
     -Denable-uefi=true \
     -Denable-dell=true \
     -Denable-synaptics=true \
diff --git a/contrib/fwupd.spec.in b/contrib/fwupd.spec.in
index 3e47182c6a..80eed8f3cf 100644
--- a/contrib/fwupd.spec.in
+++ b/contrib/fwupd.spec.in
@@ -142,7 +142,7 @@ Data files for installed tests.
 %else
     -Denable-dummy=false \
 %endif
-    -Denable-thunderbolt=false \
+    -Denable-thunderbolt=true \
 %if 0%{?have_uefi}
     -Denable-uefi=true \
     -Denable-uefi-labels=true \
diff --git a/data/tests/thunderbolt/minimal-fw-controller.bin b/data/tests/thunderbolt/minimal-fw-controller.bin
new file mode 100644
index 0000000000..f7d45e415e
Binary files /dev/null and b/data/tests/thunderbolt/minimal-fw-controller.bin differ
diff --git a/data/tests/thunderbolt/minimal-fw.bin b/data/tests/thunderbolt/minimal-fw.bin
new file mode 100644
index 0000000000..405eb5ecd2
Binary files /dev/null and b/data/tests/thunderbolt/minimal-fw.bin differ
diff --git a/plugins/thunderbolt/fu-plugin-thunderbolt.c b/plugins/thunderbolt/fu-plugin-thunderbolt.c
index 0749dc05a4..f977d68827 100644
--- a/plugins/thunderbolt/fu-plugin-thunderbolt.c
+++ b/plugins/thunderbolt/fu-plugin-thunderbolt.c
@@ -35,6 +35,7 @@
 #include "fu-plugin-thunderbolt.h"
 #include "fu-plugin-vfuncs.h"
 #include "fu-device-metadata.h"
+#include "fu-thunderbolt-image.h"
 
 G_DEFINE_AUTOPTR_CLEANUP_FUNC(GUdevDevice, g_object_unref)
 
@@ -57,7 +58,6 @@ struct FuPluginData {
 	guint timeout;
 };
 
-
 static gchar *
 fu_plugin_thunderbolt_gen_id_from_syspath (const gchar *syspath)
 {
@@ -322,17 +322,12 @@ udev_uevent_cb (GUdevClient *udev,
 	return TRUE;
 }
 
-static gboolean
-fu_plugin_thunderbolt_validate_firmware (GBytes *blob_fw, GError **error)
-{
-	/* FIXME: need to implement */
-	return TRUE;
-}
-
 static GFile *
 fu_plugin_thunderbolt_find_nvmem (GUdevDevice  *udevice,
+				  gboolean      active,
 				  GError      **error)
 {
+	const gchar *nvmem_dir = active ? "nvm_active" : "nvm_non_active";
 	const gchar *devpath;
 	const gchar *name;
 	g_autoptr(GDir) d = NULL;
@@ -350,7 +345,7 @@ fu_plugin_thunderbolt_find_nvmem (GUdevDevice  *udevice,
 		return NULL;
 
 	while ((name = g_dir_read_name (d)) != NULL) {
-		if (g_str_has_prefix (name, "nvm_non_active")) {
+		if (g_str_has_prefix (name, nvmem_dir)) {
 			g_autoptr(GFile) parent = g_file_new_for_path (devpath);
 			g_autoptr(GFile) nvm_dir = g_file_get_child (parent, name);
 			return g_file_get_child (nvm_dir, "nvmem");
@@ -363,6 +358,30 @@ fu_plugin_thunderbolt_find_nvmem (GUdevDevice  *udevice,
 	return NULL;
 }
 
+static enum FuPluginValidation
+fu_plugin_thunderbolt_validate_firmware (GUdevDevice  *udevice,
+					 GBytes       *blob_fw,
+					 GError      **error)
+{
+	g_autoptr(GFile) nvmem = NULL;
+	g_autoptr(GBytes) controller_fw = NULL;
+	gchar *content;
+	gsize length;
+
+	nvmem = fu_plugin_thunderbolt_find_nvmem (udevice, TRUE, error);
+	if (nvmem == NULL)
+		return VALIDATION_FAILED;
+
+	if (!g_file_load_contents (nvmem, NULL, &content, &length, NULL, error))
+		return VALIDATION_FAILED;
+
+	controller_fw = g_bytes_new_take (content, length);
+
+	return fu_plugin_thunderbolt_validate_image (controller_fw,
+						     blob_fw,
+						     error);
+}
+
 static gboolean
 fu_plugin_thunderbolt_trigger_update (GUdevDevice  *udevice,
 				      GError      **error)
@@ -436,7 +455,7 @@ fu_plugin_thunderbolt_write_firmware (FuPlugin     *plugin,
 	g_autoptr(GFile) nvmem = NULL;
 	g_autoptr(GOutputStream) os = NULL;
 
-	nvmem = fu_plugin_thunderbolt_find_nvmem (udevice, error);
+	nvmem = fu_plugin_thunderbolt_find_nvmem (udevice, FALSE, error);
 	if (nvmem == NULL)
 		return FALSE;
 
@@ -721,15 +740,8 @@ fu_plugin_update (FuPlugin *plugin,
 	guint64 status;
 	g_autoptr(GUdevDevice) udevice = NULL;
 	g_autoptr(GError) error_local = NULL;
-
-	if (!fu_plugin_thunderbolt_validate_firmware (blob_fw, &error_local)) {
-		g_set_error (error,
-			     FWUPD_ERROR,
-			     FWUPD_ERROR_NOT_FOUND,
-			     "could not validate firmware: %s",
-			     error_local->message);
-		return FALSE;
-	}
+	gboolean force = (flags & FWUPD_INSTALL_FLAG_FORCE) != 0;
+	enum FuPluginValidation validation;
 
 	devpath = fu_device_get_metadata (dev, "sysfs-path");
 	g_return_val_if_fail (devpath, FALSE);
@@ -744,6 +756,37 @@ fu_plugin_update (FuPlugin *plugin,
 		return FALSE;
 	}
 
+	validation = fu_plugin_thunderbolt_validate_firmware (udevice,
+							      blob_fw,
+							      &error_local);
+	if (validation != VALIDATION_PASSED) {
+		g_autofree gchar* msg = NULL;
+		switch (validation) {
+		case VALIDATION_FAILED:
+			msg = g_strdup_printf ("could not validate firmware: %s",
+					       error_local->message);
+			break;
+		case VALIDATION_PASSED_UNKNOWN_DEVICE:
+			msg = g_strdup ("firmware validation seems to be passed but the device is unknown");
+			break;
+		default:
+			break;
+		}
+		if (!force) {
+			g_set_error (error,
+				     FWUPD_ERROR,
+				     FWUPD_ERROR_INVALID_FILE,
+				     "%s\n"
+				     "To update anyway please run the update with --force.",
+				     msg);
+			return FALSE;
+		}
+		g_warning ("%s\n"
+			   "Continuing anyway as --force specified",
+			   msg);
+		g_clear_error (error);
+	}
+
 	fu_plugin_set_status (plugin, FWUPD_STATUS_DEVICE_WRITE);
 	if (!fu_plugin_thunderbolt_write_firmware (plugin, udevice, blob_fw, &error_local)) {
 		g_set_error (error,
diff --git a/plugins/thunderbolt/fu-self-test.c b/plugins/thunderbolt/fu-self-test.c
index e8e73c03bd..755b45636f 100644
--- a/plugins/thunderbolt/fu-self-test.c
+++ b/plugins/thunderbolt/fu-self-test.c
@@ -64,14 +64,15 @@ udev_mock_add_domain (UMockdevTestbed *bed, int id)
 
 
 static gchar *
-udev_mock_add_nvme_nonactive (UMockdevTestbed *bed,
-			      const char      *parent,
-			      int              id)
+udev_mock_add_nvmem (UMockdevTestbed *bed,
+		     gboolean         active,
+		     const char      *parent,
+		     int              id)
 {
 	g_autofree gchar *name = NULL;
 	gchar *path;
 
-	name = g_strdup_printf ("nvm_non_active%d", id);
+	name = g_strdup_printf ("%s%d", active ? "nvm_active" : "nvm_non_active", id);
 	path = umockdev_testbed_add_device (bed, "nvmem", name,
 					    parent,
 					    "nvmem", "",
@@ -116,7 +117,8 @@ struct MockTree {
 
 	UMockdevTestbed *bed;
 	gchar  *path;
-	gchar  *nvm_device;
+	gchar  *nvm_non_active;
+	gchar  *nvm_active;
 	guint   nvm_authenticate;
 	gchar  *nvm_version;
 
@@ -158,9 +160,14 @@ mock_tree_free (MockTree *tree)
 
 	g_free (tree->uuid);
 	if (tree->bed != NULL) {
-		if (tree->nvm_device) {
-			umockdev_testbed_uevent (tree->bed, tree->nvm_device, "remove");
-			umockdev_testbed_remove_device (tree->bed, tree->nvm_device);
+		if (tree->nvm_active) {
+			umockdev_testbed_uevent (tree->bed, tree->nvm_active, "remove");
+			umockdev_testbed_remove_device (tree->bed, tree->nvm_active);
+		}
+
+		if (tree->nvm_non_active) {
+			umockdev_testbed_uevent (tree->bed, tree->nvm_non_active, "remove");
+			umockdev_testbed_remove_device (tree->bed, tree->nvm_non_active);
 		}
 
 		if (tree->path) {
@@ -173,7 +180,8 @@ mock_tree_free (MockTree *tree)
 	}
 
 	g_free (tree->nvm_version);
-	g_free (tree->nvm_device);
+	g_free (tree->nvm_active);
+	g_free (tree->nvm_non_active);
 	g_free (tree->path);
 	g_free (tree->sysfs_parent);
 	g_slice_free (MockTree, tree);
@@ -216,8 +224,10 @@ mock_tree_dump (const MockTree *node, int level)
 	if (node->path) {
 		g_debug ("%*s * %s [%s] at %s", level, " ",
 			 node->device->name, node->uuid, node->path);
-		g_debug ("%*s   nvmem at %s", level, " ",
-			 node->nvm_device);
+		g_debug ("%*s   non-active nvmem at %s", level, " ",
+			 node->nvm_non_active);
+		g_debug ("%*s   active nvmem at %s", level, " ",
+			 node->nvm_active);
 	} else {
 		g_debug ("%*s * %s [%s] %d", level, " ",
 			 node->device->name, node->uuid, node->sysfs_id);
@@ -245,9 +255,9 @@ mock_tree_firmware_verify (const MockTree *node, GBytes *data)
 	chk = g_checksum_new (G_CHECKSUM_SHA1);
 
 	g_assert_nonnull (node);
-	g_assert_nonnull (node->nvm_device);
+	g_assert_nonnull (node->nvm_non_active);
 
-	nvm_device = g_file_new_for_path (node->nvm_device);
+	nvm_device = g_file_new_for_path (node->nvm_non_active);
 	nvm = g_file_get_child (nvm_device, "nvmem");
 
 	is = (GInputStream *) g_file_read (nvm, NULL, &error);
@@ -338,6 +348,50 @@ mock_tree_node_have_fu_device (const MockTree *node, gpointer data)
 	return node->fu_device != NULL;
 }
 
+static void
+write_controller_fw (const gchar *nvm)
+{
+	g_autoptr(GFile) nvm_device = NULL;
+	g_autoptr(GFile) nvmem = NULL;
+	g_autofree gchar *fw_path = NULL;
+	g_autoptr(GFile) fw_file = NULL;
+	g_autoptr(GInputStream) is = NULL;
+	g_autoptr(GOutputStream) os = NULL;
+	g_autoptr(GError) error = NULL;
+	gssize n;
+
+	fw_path = fu_test_get_filename (TESTDATADIR, "thunderbolt/minimal-fw-controller.bin");
+	g_assert_nonnull (fw_path);
+
+	fw_file = g_file_new_for_path (fw_path);
+	g_assert_nonnull (fw_file);
+
+	nvm_device = g_file_new_for_path (nvm);
+	g_assert_nonnull (nvm_device);
+
+	nvmem = g_file_get_child (nvm_device, "nvmem");
+	g_assert_nonnull (nvmem);
+
+	os = (GOutputStream *) g_file_append_to (nvmem,
+						 G_FILE_CREATE_NONE,
+						 NULL,
+						 &error);
+	g_assert_no_error (error);
+	g_assert_nonnull (os);
+
+	is = (GInputStream *) g_file_read (fw_file, NULL, &error);
+	g_assert_no_error (error);
+	g_assert_nonnull (is);
+
+	n = g_output_stream_splice (os,
+				    is,
+				    G_OUTPUT_STREAM_SPLICE_NONE,
+				    NULL,
+				    &error);
+	g_assert_no_error (error);
+	g_assert_cmpuint (n, >, 0);
+}
+
 static gboolean
 mock_tree_attach_device (gpointer user_data)
 {
@@ -368,12 +422,21 @@ mock_tree_attach_device (gpointer user_data)
 						  "thunderbolt_device",
 						  NULL);
 
-	tree->nvm_device = udev_mock_add_nvme_nonactive (tree->bed,
-							 tree->path,
-							 tree->sysfs_id);
+	tree->nvm_non_active = udev_mock_add_nvmem (tree->bed,
+						    FALSE,
+						    tree->path,
+						    tree->sysfs_id);
+
+	tree->nvm_active = udev_mock_add_nvmem (tree->bed,
+						TRUE,
+						tree->path,
+						tree->sysfs_id);
 
 	g_assert_nonnull (tree->path);
-	g_assert_nonnull (tree->nvm_device);
+	g_assert_nonnull (tree->nvm_non_active);
+	g_assert_nonnull (tree->nvm_active);
+
+	write_controller_fw (tree->nvm_active);
 
 	for (guint i = 0; i < tree->children->len; i++) {
 		MockTree *child;
@@ -550,10 +613,12 @@ mock_tree_node_is_detached (const MockTree *node, gpointer unused)
 	/* consistency checks: if ret, make sure we are
 	 * fully detached */
 	if (ret) {
-		g_assert_null (node->nvm_device);
+		g_assert_null (node->nvm_active);
+		g_assert_null (node->nvm_non_active);
 		g_assert_null (node->bed);
 	} else {
-		g_assert_nonnull (node->nvm_device);
+		g_assert_nonnull (node->nvm_active);
+		g_assert_nonnull (node->nvm_non_active);
 		g_assert_nonnull (node->bed);
 	}
 
@@ -577,17 +642,22 @@ mock_tree_detach (MockTree *node)
 	}
 
 	bed  = node->bed;
-	umockdev_testbed_uevent (bed, node->nvm_device, "remove");
-	umockdev_testbed_remove_device (bed, node->nvm_device);
+	umockdev_testbed_uevent (bed, node->nvm_active, "remove");
+	umockdev_testbed_remove_device (bed, node->nvm_active);
+
+	umockdev_testbed_uevent (bed, node->nvm_non_active, "remove");
+	umockdev_testbed_remove_device (bed, node->nvm_non_active);
 
 	umockdev_testbed_uevent (bed, node->path, "remove");
 	umockdev_testbed_remove_device (bed, node->path);
 
 	g_free (node->path);
-	g_free (node->nvm_device);
+	g_free (node->nvm_non_active);
+	g_free (node->nvm_active);
 
 	node->path = NULL;
-	node->nvm_device = NULL;
+	node->nvm_non_active = NULL;
+	node->nvm_active = NULL;
 
 	g_object_unref (bed);
 	node->bed = NULL;
@@ -848,7 +918,7 @@ test_set_up (ThunderboltTest *tt, gconstpointer params)
 	if (flags & TEST_PREPARE_FIRMWARE) {
 		g_autofree gchar *fw_path = NULL;
 
-		fw_path = fu_test_get_filename (TESTDATADIR, "colorhug/firmware.bin");
+		fw_path = fu_test_get_filename (TESTDATADIR, "thunderbolt/minimal-fw.bin");
 		g_assert_nonnull (fw_path);
 		tt->fw_file = g_mapped_file_new (fw_path, FALSE, &error);
 		g_assert_no_error (error);
diff --git a/plugins/thunderbolt/fu-thunderbolt-image.c b/plugins/thunderbolt/fu-thunderbolt-image.c
new file mode 100644
index 0000000000..182bd7522a
--- /dev/null
+++ b/plugins/thunderbolt/fu-thunderbolt-image.c
@@ -0,0 +1,571 @@
+/* -*- mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*-
+ *
+ * Copyright (C) 2017 Intel Corporation.
+ *
+ * Licensed under the GNU General Public License Version 2
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+ */
+
+#include "fu-thunderbolt-image.h"
+
+#include <string.h>
+#include <libfwupd/fwupd-error.h>
+
+enum FuThunderboltSection {
+	DIGITAL_SECTION,
+	DROM_SECTION,
+	ARC_PARAMS_SECTION,
+	DRAM_UCODE_SECTION,
+	SECTION_COUNT
+};
+
+typedef struct {
+	enum FuThunderboltSection  section; /* default is DIGITAL_SECTION */
+	guint32                    offset;
+	guint32                    len;
+	guint8                     mask;    /* 0 means "no mask" */
+	gchar                     *description;
+} FuThunderboltFwLocation;
+
+typedef struct {
+	const guint8 *data;
+	gsize         len;
+	guint32      *sections;
+} FuThunderboltFwObject;
+
+typedef struct {
+	guint16 id;
+	guint   gen;
+	guint   ports;
+} FuThunderboltHwInfo;
+
+static FuThunderboltHwInfo *
+get_hw_info (guint16 id)
+{
+	static const FuThunderboltHwInfo hw_info_arr[] = {
+		{ 0x156D, 2, 2 }, /* FR 4C */
+		{ 0x156B, 2, 1 }, /* FR 2C */
+		{ 0x157E, 2, 1 }, /* WR */
+
+		{ 0x1578, 3, 2 }, /* AR 4C */
+		{ 0x1576, 3, 1 }, /* AR 2C */
+		{ 0x15C0, 3, 1 }, /* AR LP */
+		{ 0x15D3, 3, 2 }, /* AR-C 4C */
+		{ 0x15DA, 3, 1 }, /* AR-C 2C */
+
+		{ 0 }
+	};
+
+	for (gint i = 0; hw_info_arr[i].id != 0; i++)
+		if (hw_info_arr[i].id == id)
+			return hw_info_arr + i;
+	return NULL;
+}
+
+static inline gboolean
+valid_farb_pointer (guint32 pointer)
+{
+	return pointer != 0 && pointer != 0xFFFFFF;
+}
+
+static GByteArray *
+read_location (const FuThunderboltFwLocation  *location,
+	       const FuThunderboltFwObject    *fw,
+	       GError                        **error)
+{
+	guint32 location_start = fw->sections[location->section] + location->offset;
+	g_autoptr(GByteArray) read = g_byte_array_new ();
+
+	if (location_start > fw->len || location_start + location->len > fw->len) {
+		g_set_error (error,
+			     FWUPD_ERROR, FWUPD_ERROR_READ,
+			     "Given location is outside of the given FW (%s)",
+			     location->description);
+		return NULL;
+	}
+
+	read = g_byte_array_append (read,
+				    fw->data + location_start,
+				    location->len);
+
+	if (location->mask)
+		read->data[0] &= location->mask;
+	return g_steal_pointer (&read);
+}
+
+static guint32
+read_farb_pointer_impl (const FuThunderboltFwLocation  *location,
+			const FuThunderboltFwObject    *fw,
+			GError                        **error)
+{
+	guint32 value = 0;
+	g_autoptr(GByteArray) farb = read_location (location, fw, error);
+	if (farb == NULL)
+		return 0;
+	memcpy (&value, farb->data, farb->len);
+	return GUINT32_FROM_LE (value);
+}
+
+static guint32
+read_farb_pointer (const FuThunderboltFwObject *fw, GError **error)
+{
+	const FuThunderboltFwLocation farb1 = { .offset = 0,      .len = 3 };
+	const FuThunderboltFwLocation farb2 = { .offset = 0x1000, .len = 3 };
+
+	guint32 ret = read_farb_pointer_impl (&farb1, fw, error);
+	if (*error != NULL)
+		return ret;
+	if (valid_farb_pointer (ret))
+		return ret;
+
+	ret = read_farb_pointer_impl (&farb2, fw, error);
+	if (!valid_farb_pointer (ret)) {
+		g_set_error_literal (error,
+				     FWUPD_ERROR, FWUPD_ERROR_INVALID_FILE,
+				     "Invalid FW image file format");
+		return 0;
+	}
+
+	return ret;
+}
+
+static gboolean
+compare (const FuThunderboltFwLocation  *location,
+	 const FuThunderboltFwObject    *controller_fw,
+	 const FuThunderboltFwObject    *image_fw,
+	 gboolean                       *result,
+	 GError                        **error)
+{
+	g_autoptr(GByteArray) controller_data = NULL;
+	g_autoptr(GByteArray) image_data      = NULL;
+
+	controller_data = read_location (location, controller_fw, error);
+	if (controller_data == NULL)
+		return FALSE;
+
+	image_data = read_location (location, image_fw, error);
+	if (image_data == NULL)
+		return FALSE;
+
+	*result = memcmp (controller_data->data, image_data->data, location->len) == 0;
+	return TRUE;
+}
+
+static void
+read_bool (const FuThunderboltFwLocation  *location,
+	   const FuThunderboltFwObject    *fw,
+	   gboolean                       *val,
+	   GError                        **error)
+{
+	g_autoptr(GByteArray) read = read_location (location, fw, error);
+	if (read == NULL)
+		return;
+	for (gsize i = 0; i < read->len; i++)
+		if (read->data[i] != 0) {
+			*val = TRUE;
+			return;
+		}
+	*val = FALSE;
+	return;
+}
+
+static guint16
+read_uint16 (const FuThunderboltFwLocation  *location,
+	     const FuThunderboltFwObject    *fw,
+	     GError                        **error)
+{
+	guint16 value = 0;
+	g_autoptr(GByteArray) read = read_location (location, fw, error);
+	g_assert_cmpuint (location->len, ==, sizeof (guint16));
+	if (read == NULL)
+		return 0;
+
+	memcpy (&value, read->data, read->len);
+	return GUINT16_FROM_LE (value);
+}
+
+static guint32
+read_uint32 (const FuThunderboltFwLocation  *location,
+	     const FuThunderboltFwObject    *fw,
+	     GError                        **error)
+{
+	guint32 value = 0;
+	g_autoptr(GByteArray) read = read_location (location, fw, error);
+	g_assert_cmpuint (location->len, ==, sizeof (guint32));
+	if (read == NULL)
+		return 0;
+
+	memcpy (&value, read->data, read->len);
+	return GUINT32_FROM_LE (value);
+}
+
+/*
+ * Size of ucode sections is uint16 value saved at the start of the section,
+ * it's in DWORDS (4-bytes) units and it doesn't include itself. We need the
+ * offset to the next section, so we translate it to bytes and add 2 for the
+ * size field itself.
+ *
+ * offset parameter must be relative to digital section
+ */
+static inline guint16
+read_ucode_section_len (guint32 offset, const FuThunderboltFwObject *fw, GError **error)
+{
+	const FuThunderboltFwLocation section_size = { .offset = offset, .len = 2 };
+	guint16 size = read_uint16 (&section_size, fw, error);
+	if (*error != NULL)
+		return 0;
+	return sizeof (guint32) * size + sizeof (size);
+}
+
+/*
+ * Takes a FwObject and fills its section array up
+ * Assumes sections[DIGITAL_SECTION].offset is already set
+ */
+static gboolean
+read_sections (FuThunderboltFwObject *fw, gboolean is_host, guint gen, GError **error)
+{
+	const FuThunderboltFwLocation arc_params_offset = { .offset = 0x75,  .len = 4 };
+	const FuThunderboltFwLocation drom_offset       = { .offset = 0x10E, .len = 4 };
+
+	if (gen >= 3 || gen == 0)
+		fw->sections[DROM_SECTION] = read_uint32 (&drom_offset, fw, error) +
+					     fw->sections[DIGITAL_SECTION];
+	if (*error != NULL)
+		return FALSE;
+
+	if (!is_host) {
+		fw->sections[ARC_PARAMS_SECTION] =
+				read_uint32 (&arc_params_offset, fw, error) +
+				fw->sections[DIGITAL_SECTION];
+		if (*error != NULL)
+			return FALSE;
+	}
+
+	if (is_host && gen > 2) {
+		/*
+		 * Algorithm:
+		 * To find the DRAM section, we have to jump from section to
+		 * section in a chain of sections.
+		 * available_sections location tells what sections exist at all
+		 * (with a flag per section).
+		 * ee_ucode_start_addr location tells the offset of the first
+		 * section in the list relatively to the digital section start.
+		 * After having the offset of the first section, we have a loop
+		 * over the section list. If the section exists, we read its
+		 * length (2 bytes at section start) and add it to current
+		 * offset to find the start of the next section. Otherwise, we
+		 * already have the next section offset...
+		 */
+		const unsigned DRAM_FLAG = 1 << 6;
+		const FuThunderboltFwLocation available_sections_loc  = { .offset = 0x2, .len = 1 };
+		const FuThunderboltFwLocation ee_ucode_start_addr_loc = { .offset = 0x3, .len = 2 };
+
+		guint32 offset;
+
+		g_autoptr(GByteArray) available_sections =
+				read_location (&available_sections_loc, fw, error);
+		if (*error != NULL)
+			return FALSE;
+
+		offset = read_uint16 (&ee_ucode_start_addr_loc, fw, error);
+		if (*error != NULL)
+			return FALSE;
+
+		if ((available_sections->data[0] & DRAM_FLAG) == 0)
+			return FALSE;
+
+		for (unsigned u = 1; u < DRAM_FLAG; u <<= 1)
+			if (u & available_sections->data[0]) {
+				offset += read_ucode_section_len (offset, fw, error);
+				if (*error != NULL)
+					return FALSE;
+			}
+
+		fw->sections[DRAM_UCODE_SECTION] = offset + fw->sections[DIGITAL_SECTION];
+		if (*error != NULL)
+			return FALSE;
+	}
+
+	return TRUE;
+}
+
+static inline gboolean
+missing_needed_drom (const FuThunderboltFwObject *fw, gboolean is_host, guint gen)
+{
+	if (fw->sections[DROM_SECTION] != 0)
+		return FALSE;
+	if (is_host && gen < 3)
+		return FALSE;
+	return TRUE;
+}
+
+/*
+ * Controllers that can have 1 or 2 ports have additional locations to check in
+ * the 2 ports case. To make this as generic as possible, both sets are stored
+ * in the same array with an empty entry separating them. The 1 port case should
+ * stop comparing at the separator and the 2 ports case should continue
+ * iterating the array to compare the rest.
+ */
+static FuThunderboltFwLocation *
+get_host_locations (guint16 id)
+{
+	static const FuThunderboltFwLocation FR[] = {
+		{ .offset = 0x10,   .len = 4, .description = "PCIe Settings" },
+		{ .offset = 0x143,  .len = 1, .description = "CIO-Port0_TX"  },
+		{ .offset = 0x153,  .len = 1, .description = "CIO-Port0_RX"  },
+		{ .offset = 0x147,  .len = 1, .description = "CIO-Port1_TX"  },
+		{ .offset = 0x157,  .len = 1, .description = "CIO-Port1_RX"  },
+		{ .offset = 0x211,  .len = 1, .description = "Snk0_0(DP-in)" },
+		{ .offset = 0x215,  .len = 1, .description = "Snk0_1(DP-in)" },
+		{ .offset = 0x219,  .len = 1, .description = "Snk0_2(DP-in)" },
+		{ .offset = 0x21D,  .len = 1, .description = "Snk0_3(DP-in)" },
+		{ .offset = 0X2175, .len = 1, .description = "PA(DP-out)"    },
+		{ .offset = 0X2179, .len = 1, .description = "PB(DP-out)"    },
+		{ .offset = 0X217D, .len = 1, .description = "Src0(DP-out)", .mask = 0xAA },
+		{ 0 },
+
+		{ .offset = 0x14B,  .len = 1, .description = "CIO-Port2_TX"  },
+		{ .offset = 0x15B,  .len = 1, .description = "CIO-Port2_RX"  },
+		{ .offset = 0x14F,  .len = 1, .description = "CIO-Port3_TX"  },
+		{ .offset = 0x15F,  .len = 1, .description = "CIO-Port3_RX"  },
+		{ .offset = 0X11C3, .len = 1, .description = "Snk1_0(DP-in)" },
+		{ .offset = 0X11C7, .len = 1, .description = "Snk1_1(DP-in)" },
+		{ .offset = 0X11CB, .len = 1, .description = "Snk1_2(DP-in)" },
+		{ .offset = 0X11CF, .len = 1, .description = "Snk1_3(DP-in)" },
+		{ 0 }
+	};
+
+	static const FuThunderboltFwLocation WR[] = {
+		{ .offset = 0x10,   .len = 4, .description = "PCIe Settings" },
+		{ .offset = 0x14F,  .len = 1, .description = "CIO-Port0_TX"  },
+		{ .offset = 0x157,  .len = 1, .description = "CIO-Port0_RX"  },
+		{ .offset = 0x153,  .len = 1, .description = "CIO-Port1_TX"  },
+		{ .offset = 0x15B,  .len = 1, .description = "CIO-Port1_RX"  },
+		{ .offset = 0x1F1,  .len = 1, .description = "Snk0_0(DP-in)" },
+		{ .offset = 0x1F5,  .len = 1, .description = "Snk0_1(DP-in)" },
+		{ .offset = 0x1F9,  .len = 1, .description = "Snk0_2(DP-in)" },
+		{ .offset = 0x1FD,  .len = 1, .description = "Snk0_3(DP-in)" },
+		{ .offset = 0X11A5, .len = 1, .description = "PA(DP-out)"    },
+		{ 0 }
+	};
+
+	static const FuThunderboltFwLocation AR[] = {
+		{ .offset = 0x10,  .len = 4, .description = "PCIe Settings" },
+		{ .offset = 0x12,  .len = 1, .description = "PA", .mask = 0xCC, .section = DRAM_UCODE_SECTION },
+		{ .offset = 0x121, .len = 1, .description = "Snk0" },
+		{ .offset = 0x129, .len = 1, .description = "Snk1" },
+		{ .offset = 0x136, .len = 1, .description = "Src0", .mask = 0xF0 },
+		{ .offset = 0xB6,  .len = 1, .description = "PA/PB (USB2)", .mask = 0xC0 },
+		{ 0 },
+
+		{ .offset = 0x13, .len = 1, .description = "PB", .mask = 0xCC, .section = DRAM_UCODE_SECTION },
+		{ 0 }
+	};
+
+	static const FuThunderboltFwLocation AR_LP[] = {
+		{ .offset = 0x10,  .len = 4, .description = "PCIe Settings" },
+		{ .offset = 0x12,  .len = 1, .description = "PA", .mask = 0xCC, .section = DRAM_UCODE_SECTION },
+		{ .offset = 0x13,  .len = 1, .description = "PB", .mask = 0x44, .section = DRAM_UCODE_SECTION },
+		{ .offset = 0x121, .len = 1, .description = "Snk0" },
+		{ .offset = 0xB6,  .len = 1, .description = "PA/PB (USB2)", .mask = 0xC0 },
+		{ 0 }
+	};
+
+	switch (id) {
+	case 0x156D:
+	case 0x156B:
+		return FR;
+	case 0x157E:
+		return WR;
+	case 0x1578:
+	case 0x1576:
+	case 0x15D3:
+	case 0x15DA:
+		return AR;
+	case 0x15C0:
+		return AR_LP;
+	default:
+		return NULL;
+	}
+}
+
+static FuThunderboltFwLocation *
+get_device_locations (guint16 id)
+{
+	static const FuThunderboltFwLocation locations[] = {
+		{ .offset = 0x124, .len = 1, .section = ARC_PARAMS_SECTION, .description = "X of N" },
+		{ 0 }
+	};
+
+	switch (id) {
+	case 0x1578:
+	case 0x1576:
+	case 0x15D3:
+	case 0x15DA:
+	case 0x15C0:
+	case 0:
+		return locations;
+	default:
+		return NULL;
+	}
+}
+
+/*
+ * Compares the given locations, assuming locations is an array.
+ * Returns FALSE and sets error upon failure.
+ * locations points to the end of the array (the empty entry) upon
+ * successful return.
+ */
+static gboolean
+compare_locations (const FuThunderboltFwLocation **locations,
+		   const FuThunderboltFwObject    *controller,
+		   const FuThunderboltFwObject    *image,
+		   GError                        **error)
+{
+	gboolean result;
+	do {
+		if (!compare (*locations, controller, image, &result, error))
+			return FALSE;
+		if (!result) {
+			g_set_error (error,
+				     FWUPD_ERROR, FWUPD_ERROR_INVALID_FILE,
+				     "FW image image not compatible to this controller (%s)",
+				     (*locations)->description);
+			return FALSE;
+		}
+	} while ((++(*locations))->offset != 0);
+	return TRUE;
+}
+
+enum FuPluginValidation
+fu_plugin_thunderbolt_validate_image (GBytes  *controller_fw,
+				      GBytes  *blob_fw,
+				      GError **error)
+{
+	gboolean is_host;
+	guint16 device_id;
+	gboolean compare_result;
+	const FuThunderboltHwInfo *hw_info;
+	const FuThunderboltHwInfo unknown = { 0 };
+	const FuThunderboltFwLocation *locations;
+
+	gsize fw_size;
+	const guint8 *fw_data = g_bytes_get_data (controller_fw, &fw_size);
+
+	gsize blob_size;
+	const guint8 *blob_data = g_bytes_get_data (blob_fw, &blob_size);
+
+	guint32 controller_sections[SECTION_COUNT] = { [DIGITAL_SECTION] = 0 };
+	guint32 image_sections     [SECTION_COUNT] = { 0 };
+
+	const FuThunderboltFwObject controller = { fw_data,   fw_size,   controller_sections };
+	const FuThunderboltFwObject image      = { blob_data, blob_size, image_sections };
+
+	const FuThunderboltFwLocation is_host_loc   = { .offset = 0x10, .len = 1, .mask = 1 << 1 };
+	const FuThunderboltFwLocation device_id_loc = { .offset = 0x5,  .len = 2 };
+
+	image_sections[DIGITAL_SECTION] = read_farb_pointer (&image, error);
+	if (image_sections[DIGITAL_SECTION] == 0)
+		return VALIDATION_FAILED;
+
+	read_bool (&is_host_loc, &controller, &is_host, error);
+	if (*error != NULL)
+		return VALIDATION_FAILED;
+
+	device_id = read_uint16 (&device_id_loc, &controller, error);
+	if (*error != NULL)
+		return VALIDATION_FAILED;
+
+	hw_info = get_hw_info (device_id);
+	if (hw_info == NULL) {
+		if (is_host) {
+			g_set_error (error,
+				     FWUPD_ERROR, FWUPD_ERROR_NOT_SUPPORTED,
+				     "Unknown controller");
+			return FALSE;
+		}
+		hw_info = &unknown;
+	}
+
+	if (!compare (&is_host_loc, &controller, &image, &compare_result, error))
+		return VALIDATION_FAILED;
+	if (!compare_result) {
+		g_set_error (error,
+			     FWUPD_ERROR, FWUPD_ERROR_INVALID_FILE,
+			     "The FW image file is for a %s controller",
+			     is_host ? "device" : "host");
+		return VALIDATION_FAILED;
+	}
+
+	if (!compare (&device_id_loc, &controller, &image, &compare_result, error))
+		return VALIDATION_FAILED;
+	if (!compare_result) {
+		g_set_error_literal (error,
+				     FWUPD_ERROR, FWUPD_ERROR_INVALID_FILE,
+				     "The FW image file is for a different HW type");
+		return VALIDATION_FAILED;
+	}
+
+	if (!read_sections (&controller, is_host, hw_info->gen, error) ||
+	    missing_needed_drom (&controller, is_host, hw_info->gen)) {
+		if (*error == NULL)
+			g_set_error_literal (error,
+					     FWUPD_ERROR, FWUPD_ERROR_READ,
+					     "Can't find needed FW sections in the controller");
+		return VALIDATION_FAILED;
+	}
+
+	if (!read_sections (&image, is_host, hw_info->gen, error) ||
+	    missing_needed_drom (&image, is_host, hw_info->gen)) {
+		if (*error == NULL)
+			g_set_error_literal (error,
+					     FWUPD_ERROR, FWUPD_ERROR_INVALID_FILE,
+					     "Can't find needed FW sections in the FW image file");
+		return VALIDATION_FAILED;
+	}
+
+	if (controller.sections[DROM_SECTION] != 0) {
+		const FuThunderboltFwLocation drom_locations[] = {
+			{ .offset = 0x10, .len = 2, .section = DROM_SECTION, .description = "vendor ID" },
+			{ .offset = 0x12, .len = 2, .section = DROM_SECTION, .description = "model ID" },
+			{ 0 }
+		};
+		locations = drom_locations;
+		if (!compare_locations (&locations, &controller, &image, error))
+			return VALIDATION_FAILED;
+	}
+
+	locations = is_host ?
+			    get_host_locations (hw_info->id) :
+			    get_device_locations (hw_info->id);
+	if (locations == NULL) {
+		g_set_error_literal (error,
+				     FWUPD_ERROR, FWUPD_ERROR_NOT_SUPPORTED,
+				     "FW locations to check not found for this controller");
+		return VALIDATION_FAILED;
+	}
+
+	if (!compare_locations (&locations, &controller, &image, error))
+		return VALIDATION_FAILED;
+
+	if (is_host && hw_info->ports == 2) {
+		locations++;
+		if (!compare_locations (&locations, &controller, &image, error))
+			return VALIDATION_FAILED;
+	}
+
+	return hw_info->id != 0 ? VALIDATION_PASSED : VALIDATION_PASSED_UNKNOWN_DEVICE;
+}
diff --git a/plugins/thunderbolt/fu-thunderbolt-image.h b/plugins/thunderbolt/fu-thunderbolt-image.h
new file mode 100644
index 0000000000..82b56cfc20
--- /dev/null
+++ b/plugins/thunderbolt/fu-thunderbolt-image.h
@@ -0,0 +1,37 @@
+/* -*- mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*-
+ *
+ * Copyright (C) 2017 Intel Corporation.
+ *
+ * Licensed under the GNU General Public License Version 2
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+ */
+
+#ifndef __FU_THUNDERBOLT_IMAGE_H__
+#define __FU_THUNDERBOLT_IMAGE_H__
+
+#include <glib.h>
+
+enum FuPluginValidation {
+	VALIDATION_PASSED,
+	VALIDATION_FAILED,
+	VALIDATION_PASSED_UNKNOWN_DEVICE,
+};
+
+enum FuPluginValidation	fu_plugin_thunderbolt_validate_image	(GBytes  *controller_fw,
+								 GBytes  *blob_fw,
+								 GError **error);
+
+#endif /* __FU_THUNDERBOLT_IMAGE_H__ */
diff --git a/plugins/thunderbolt/fu-thunderbolt-tool.c b/plugins/thunderbolt/fu-thunderbolt-tool.c
new file mode 100644
index 0000000000..e465fb31cb
--- /dev/null
+++ b/plugins/thunderbolt/fu-thunderbolt-tool.c
@@ -0,0 +1,103 @@
+/* -*- mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*-
+ *
+ * Copyright (C) 2017 Intel Corporation.
+ *
+ * Licensed under the GNU General Public License Version 2
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+ */
+
+#include <string.h>
+#include <glib.h>
+
+#include "fu-thunderbolt-image.h"
+#include "fu-plugin-vfuncs.h"
+#include "fu-test.h"
+
+static gsize
+read_farb_pointer (gchar *image)
+{
+	gsize ret = 0;
+	memcpy (&ret, image, 3);
+	ret = GSIZE_FROM_LE (ret);
+	if (ret != 0 && ret != 0xFFFFFF)
+		return ret;
+	ret = 0;
+	memcpy (&ret, image + 0x1000, 3);
+	ret = GSIZE_FROM_LE (ret);
+	g_assert (ret != 0 && ret != 0xFFFFFF);
+	return ret;
+}
+
+int
+main (int argc, char **argv)
+{
+	g_autoptr(GError) error = NULL;
+	g_autoptr(GFile) fw_file = NULL;
+	gboolean ok;
+	gsize len;
+	gchar *data = NULL;
+	g_autoptr(GBytes) image = NULL;
+	g_autoptr(GBytes) controller = NULL;
+	enum FuPluginValidation validation;
+
+	if (argc < 2 || argc > 3) {
+		g_print ("Usage: %s <filename> [<controller>]\n", argv[0]);
+		g_print ("Runs image validation on 'filename', comparing it to itself\n"
+			 "after removing the headers or to 'controller' if given\n");
+		return 1;
+	}
+
+	fw_file = g_file_new_for_path (argv[1]);
+	g_assert_nonnull (fw_file);
+
+	ok = g_file_load_contents (fw_file, NULL, &data, &len, NULL, &error);
+	g_assert_no_error (error);
+	g_assert_true (ok);
+
+	image = g_bytes_new_take (data, len);
+
+	if (argc == 2) {
+		gssize header_size = read_farb_pointer (data);
+		g_assert_cmpuint (header_size, !=, 0);
+
+		controller = g_bytes_new_from_bytes (image, header_size, len - header_size);
+	} else {
+		g_autoptr(GFile) controller_file = NULL;
+		gsize controller_len;
+		gchar *controller_data = NULL;
+
+		controller_file = g_file_new_for_path (argv[2]);
+		g_assert_nonnull (controller_file);
+
+		ok = g_file_load_contents (controller_file,
+					   NULL,
+					   &controller_data,
+					   &controller_len,
+					   NULL,
+					   &error);
+		g_assert_no_error (error);
+		g_assert_true (ok);
+
+		controller = g_bytes_new_take (controller_data, controller_len);
+	}
+
+	validation = fu_plugin_thunderbolt_validate_image (controller, image, &error);
+	g_assert_no_error (error);
+	g_assert_cmpint (validation, ==, VALIDATION_PASSED);
+
+	g_print ("test passed\n");
+	return 0;
+}
diff --git a/plugins/thunderbolt/meson.build b/plugins/thunderbolt/meson.build
index 12f1954326..b6a4e59001 100644
--- a/plugins/thunderbolt/meson.build
+++ b/plugins/thunderbolt/meson.build
@@ -1,8 +1,9 @@
 cargs = ['-DG_LOG_DOMAIN="FuPluginThunderbolt"']
 
-shared_module('fu_plugin_thunderbolt',
+fu_plugin_thunderbolt = shared_module('fu_plugin_thunderbolt',
   sources : [
     'fu-plugin-thunderbolt.c',
+    'fu-thunderbolt-image.c',
   ],
   include_directories : [
     include_directories('../..'),
@@ -18,18 +19,40 @@ shared_module('fu_plugin_thunderbolt',
   ],
 )
 
+testdatadir_src = join_paths(meson.source_root(), 'data', 'tests')
+testdatadir_dst = join_paths(meson.build_root(), 'data', 'tests')
+cargs += '-DTESTDATADIR="' + testdatadir_src + ':' + testdatadir_dst + '"'
+executable('tbtfwucli',
+  sources : [
+    'fu-thunderbolt-tool.c',
+  ],
+  include_directories : [
+    include_directories('../..'),
+    include_directories('../../src'),
+    include_directories('../../libfwupd'),
+  ],
+  c_args : cargs,
+  link_with : [
+    fu_plugin_thunderbolt,
+    fwupd,
+    libfwupdprivate,
+  ],
+  dependencies : [
+    plugin_deps,
+    gudev,
+  ],
+)
+
 # we use functions from 2.52 in the tests
 if get_option('enable-tests') and umockdev.found() and gio.version().version_compare('>= 2.52')
   cargs += '-DFU_OFFLINE_DESTDIR="/tmp/fwupd-self-test"'
   cargs += '-DPLUGINBUILDDIR="' + meson.current_build_dir() + '"'
-  testdatadir_src = join_paths(meson.source_root(), 'data', 'tests')
-  testdatadir_dst = join_paths(meson.build_root(), 'data', 'tests')
-  cargs += '-DTESTDATADIR="' + testdatadir_src + ':' + testdatadir_dst + '"'
   e = executable(
     'thunderbolt-self-test',
     sources : [
       'fu-self-test.c',
       'fu-plugin-thunderbolt.c',
+      'fu-thunderbolt-image.c',
     ],
     include_directories : [
       include_directories('../..'),
